Program GraafilineBitiTermiit;


uses Graph, Crt;

Const
  MaxN = 250;
  MaxT = 100;

Type

  Suund = (North, Ost, South, West);

  Koht = record
    x, y : Integer;
    end;

  PMap = ^Map;

  Map = object
    m : array [1..MaxN, 1..MaxN] of boolean;
    n : Integer;
    constructor Init(pn : Integer);
    destructor Done;
    function Invert(px, py : Integer) : Boolean;
    function Size : Integer;
    function Count : LongInt;
  end;

  PTermiit = ^Termiit;

  Termiit = object
    k : Koht;
    s : Suund;
    constructor Init(px, py : Integer; ps : Char);
    destructor Done;
    function Go(pm : PMap) : Boolean;
  end;

constructor Termiit.Init(px, py : Integer; ps : Char);
begin
  k.x := px;
  k.y := py;
  case ps of
    'N' : s := North;
    'S' : s := South;
    'W' : s := West;
    'O' : s := Ost;
  else
    begin
    writeln('Viga sisendandmetes!');
    halt;
    end
  end;
end;

destructor Termiit.Done;
begin
end;

function Termiit.Go(pm : PMap) : Boolean;
var n, d : Integer;
    pk   : ^Integer;
    b    : Boolean;
begin
  n := pm^.Size;
  case s of
    North: begin pk := @k.y; d := -1; end;
    Ost:   begin pk := @k.x; d := 1; end;
    South: begin pk := @k.y; d := 1; end;
    West:  begin pk := @k.x; d := -1; end;
  end;
  pk^ := pk^ + d;
  if pk^ = 0 then pk^ := n
  else if pk^ > n then pk^ := 1;
  b := pm^.Invert(k.x, k.y);
  case s of
    North: if b then s := West else s := Ost;
    Ost:   if b then s := North else s := South;
    South: if b then s := Ost else s := West;
    West:  if b then s := South else s := North;
  end;
  Go := b;
end;

constructor Map.Init(pn : Integer);
var i, j : Integer;
begin
  for i := 1 to pn do
    for j := 1 to pn do
      m[i,j] := false;
  n := pn;
end;

destructor Map.Done;
begin
end;

function Map.Invert(px, py : Integer) : Boolean;
begin
  m[px, py] := not m[px, py];
  Invert := m[px, py];
  if m[px, py] then
    PutPixel(px, py, white)
  else
    PutPixel(px, py, black);
end;

function Map.Size : Integer;
begin
  Size := n;
end;

function Map.Count : LongInt;
var
  i, j : Integer;
  cnt  : LongInt;
begin
  cnt := 0;
  for i := 1 to n do
    for j := 1 to n do
      if m[i,j] then inc(cnt);
  Count := cnt;
end;

Var
  Koloonia : array [1..MaxT] of PTermiit;
  Maatriks : Map;
  B, N     : Integer;
  Count, T : LongInt;
  InFile, OutFile : Text;

procedure Initialize;
var
  k, x, y : Integer;
  s       : String[3];
  grDriver: Integer;
  grMode  : Integer;
  ErrCode : Integer;
begin
  assign(InFile, 'Termiit.in');
  reset(InFile);
  readln(InFile, B, N, T);
  Maatriks.Init(N);
  for k := 1 to B do
    begin
    readln(InFile, x, y, s);
    while s[1] = ' ' do system.delete(s,1,1);
    New(Koloonia[k], Init(x, y, s[1]));
    end;
  close(InFile);

  grDriver := Detect;
  InitGraph(grDriver, grMode,' ');
  ErrCode := GraphResult;
  if ErrCode <> grOk then
    begin
    Writeln('Graphics error:', GraphErrorMsg(ErrCode));
    Halt;
    end;
end;

procedure Process;
const
  Points : array [Boolean] of Integer = (-1, 1);
var
  k : Integer;
  i : LongInt;
  c : char;
  s : String;
begin
  Count := 0;
  i := 0;
  SetFillStyle(0, black);
  repeat
    i := i + 1;
    for k := 1 to B do
      begin
      Count := Count + Points[Koloonia[k]^.Go(@Maatriks)];
      end;
    if KeyPressed then
      c := ReadKey;
    if ((i mod 100) = 0) or (c = 'q') or (i = T) then
      begin
      Bar(300, 20, 400, 80);
      Str(i, s);
      OutTextXY(300, 40, s);
      Str(Count, s);
      OutTextXY(300, 60, s);
      end;
  until (c = 'q') or (i = T);
  if i = T then
    begin
    repeat until Keypressed;
    c := ReadKey;
    end;
end;

procedure Answer;
var k : Integer;
begin
  assign(OutFile, 'Termiit.out');
  rewrite(OutFile);
  writeln(OutFile, Count, ' ', Maatriks.Count);
  close(OutFile);
  for k := 1 to B do
    Dispose(Koloonia[k], Done);
end;

begin
  Initialize;
  Process;
  Answer;
end.
